// CMComboBoxView.cpp : implementation of the CCMComboBoxView class
//

#include "stdafx.h"
#include "CMComboBox.h"
#include "MemoryComboBox.h" // MG: For new combobox class
#include "Mainfrm.h" // MG: For dialog bar demo
#include "CMComboBoxDoc.h"
#include "CMComboBoxView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCMComboBoxView

IMPLEMENT_DYNCREATE(CCMComboBoxView, CFormView)

BEGIN_MESSAGE_MAP(CCMComboBoxView, CFormView)
	//{{AFX_MSG_MAP(CCMComboBoxView)
	ON_CBN_SELCHANGE(IDC_CBCOLORS, OnSelchangeCbcolors)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
	// MG: Manually add handler for the combobox on the dialog bar
	ON_CBN_SELCHANGE( IDC_URLS, OnSelChangedURL )

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCMComboBoxView construction/destruction

CCMComboBoxView::CCMComboBoxView()
	: CFormView(CCMComboBoxView::IDD)
{
	//{{AFX_DATA_INIT(CCMComboBoxView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// TODO: add construction code here

}

CCMComboBoxView::~CCMComboBoxView()
{
}

void CCMComboBoxView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCMComboBoxView)
	DDX_Control(pDX, IDC_CBCOLORS, m_CBDemo);
	//}}AFX_DATA_MAP
}

BOOL CCMComboBoxView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CCMComboBoxView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();

	m_CBDemo.AddString( "www.openroad.org" );
	m_CBDemo.AddString( "www.opentoad.org" );

}

/////////////////////////////////////////////////////////////////////////////
// CCMComboBoxView printing

BOOL CCMComboBoxView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CCMComboBoxView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CCMComboBoxView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

void CCMComboBoxView::OnPrint(CDC* pDC, CPrintInfo* /*pInfo*/)
{
	// TODO: add customized printing code here
}

/////////////////////////////////////////////////////////////////////////////
// CCMComboBoxView diagnostics

#ifdef _DEBUG
void CCMComboBoxView::AssertValid() const
{
	CFormView::AssertValid();
}

void CCMComboBoxView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CCMComboBoxDoc* CCMComboBoxView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CCMComboBoxDoc)));
	return (CCMComboBoxDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCMComboBoxView message handlers

// MG: This is the handler for when the combobox on the main form changes
void CCMComboBoxView::OnSelchangeCbcolors() 
{
	// Add new string to combo box (will not add duplicates)
	m_CBDemo.AddString();
	
	// Determine string selected from user, either by index or text in edit box
	CString Text;
	int Index = m_CBDemo.GetCurSel();
	if( Index >= 0 )
		m_CBDemo.GetLBText( Index, Text );
	else
		m_CBDemo.GetWindowText( Text );

	MessageBox(Text);
}

// MG: This is the handler (added manually) for when the combobox in the dialog bar is changed
void CCMComboBoxView::OnSelChangedURL( )
{
	// Retrieve pointer to main frame, for our CMemoryComboBox object
	CMainFrame* pMain = (CMainFrame*)AfxGetMainWnd();
	pMain->m_DialogBarCB.AddString();

	// Get current text from the combo box:
	CString Text;
	int Index = pMain->m_DialogBarCB.GetCurSel();
	if( Index >= 0 )
		pMain->m_DialogBarCB.GetLBText( Index, Text );
	else
		pMain->m_DialogBarCB.GetWindowText( Text );

	MessageBox( Text ); // Text is now the users selection
}
